From 79919341336748ae058702f375ace04eb1d2f74a Mon Sep 17 00:00:00 2001
From: Sami Imseih <samimseih@gmail.com>
Date: Wed, 24 Jun 2026 15:01:26 +0000
Subject: [PATCH v4 4/4] [WIP] pg_stat_statements: modernize entry storage with
 pgstat kind

---
 contrib/pg_stat_statements/expected/dml.out   |    6 +
 .../expected/oldextversions.out               |   67 +
 .../pg_stat_statements/expected/select.out    |   36 +
 contrib/pg_stat_statements/meson.build        |    4 +-
 .../pg_stat_statements--1.13--1.14.sql        |  103 +
 .../pg_stat_statements/pg_stat_statements.c   | 2769 +++++++----------
 .../pg_stat_statements.conf                   |    1 +
 .../pg_stat_statements.control                |    2 +-
 contrib/pg_stat_statements/sql/dml.sql        |    1 +
 .../pg_stat_statements/sql/oldextversions.sql |    5 +
 contrib/pg_stat_statements/sql/select.sql     |   12 +
 .../t/{010_restart.pl => 001_restart.pl}      |    0
 .../t/002_query_text_memory.pl                |  124 +
 doc/src/sgml/pgstatstatements.sgml            |   39 +-
 src/tools/pgindent/typedefs.list              |    3 +
 15 files changed, 1427 insertions(+), 1745 deletions(-)
 create mode 100644 contrib/pg_stat_statements/pg_stat_statements--1.13--1.14.sql
 rename contrib/pg_stat_statements/t/{010_restart.pl => 001_restart.pl} (100%)
 create mode 100644 contrib/pg_stat_statements/t/002_query_text_memory.pl

diff --git a/contrib/pg_stat_statements/meson.build b/contrib/pg_stat_statements/meson.build
index 9d78cb88b7d..a3920669541 100644
--- a/contrib/pg_stat_statements/meson.build
+++ b/contrib/pg_stat_statements/meson.build
@@ -21,6 +21,7 @@ contrib_targets += pg_stat_statements
 install_data(
   'pg_stat_statements.control',
   'pg_stat_statements--1.4.sql',
+  'pg_stat_statements--1.13--1.14.sql',
   'pg_stat_statements--1.12--1.13.sql',
   'pg_stat_statements--1.11--1.12.sql',
   'pg_stat_statements--1.10--1.11.sql',
@@ -69,7 +70,8 @@ tests += {
   },
   'tap': {
     'tests': [
-      't/010_restart.pl',
+      't/001_restart.pl',
+      't/002_query_text_memory.pl',
     ],
   },
 }
diff --git a/contrib/pg_stat_statements/pg_stat_statements--1.13--1.14.sql b/contrib/pg_stat_statements/pg_stat_statements--1.13--1.14.sql
new file mode 100644
index 00000000000..22c799007c3
--- /dev/null
+++ b/contrib/pg_stat_statements/pg_stat_statements--1.13--1.14.sql
@@ -0,0 +1,103 @@
+/* contrib/pg_stat_statements/pg_stat_statements--1.13--1.14.sql */
+
+-- complain if script is sourced in psql, rather than via ALTER EXTENSION
+\echo Use "ALTER EXTENSION pg_stat_statements UPDATE TO '1.14'" to load this file. \quit
+
+/* First we have to remove them from the extension */
+ALTER EXTENSION pg_stat_statements DROP VIEW pg_stat_statements;
+ALTER EXTENSION pg_stat_statements DROP FUNCTION pg_stat_statements(boolean);
+
+/* Then we can drop them */
+DROP VIEW pg_stat_statements;
+DROP FUNCTION pg_stat_statements(boolean);
+
+/* Now redefine with PARALLEL RESTRICTED */
+CREATE FUNCTION pg_stat_statements(IN showtext boolean,
+    OUT userid oid,
+    OUT dbid oid,
+    OUT toplevel bool,
+    OUT queryid bigint,
+    OUT query text,
+    OUT plans int8,
+    OUT total_plan_time float8,
+    OUT min_plan_time float8,
+    OUT max_plan_time float8,
+    OUT mean_plan_time float8,
+    OUT stddev_plan_time float8,
+    OUT calls int8,
+    OUT total_exec_time float8,
+    OUT min_exec_time float8,
+    OUT max_exec_time float8,
+    OUT mean_exec_time float8,
+    OUT stddev_exec_time float8,
+    OUT rows int8,
+    OUT shared_blks_hit int8,
+    OUT shared_blks_read int8,
+    OUT shared_blks_dirtied int8,
+    OUT shared_blks_written int8,
+    OUT local_blks_hit int8,
+    OUT local_blks_read int8,
+    OUT local_blks_dirtied int8,
+    OUT local_blks_written int8,
+    OUT temp_blks_read int8,
+    OUT temp_blks_written int8,
+    OUT shared_blk_read_time float8,
+    OUT shared_blk_write_time float8,
+    OUT local_blk_read_time float8,
+    OUT local_blk_write_time float8,
+    OUT temp_blk_read_time float8,
+    OUT temp_blk_write_time float8,
+    OUT wal_records int8,
+    OUT wal_fpi int8,
+    OUT wal_bytes numeric,
+    OUT wal_buffers_full int8,
+    OUT jit_functions int8,
+    OUT jit_generation_time float8,
+    OUT jit_inlining_count int8,
+    OUT jit_inlining_time float8,
+    OUT jit_optimization_count int8,
+    OUT jit_optimization_time float8,
+    OUT jit_emission_count int8,
+    OUT jit_emission_time float8,
+    OUT jit_deform_count int8,
+    OUT jit_deform_time float8,
+    OUT parallel_workers_to_launch int8,
+    OUT parallel_workers_launched int8,
+    OUT generic_plan_calls int8,
+    OUT custom_plan_calls int8,
+    OUT stats_since timestamp with time zone,
+    OUT minmax_stats_since timestamp with time zone
+)
+RETURNS SETOF record
+AS 'MODULE_PATHNAME', 'pg_stat_statements_1_13'
+LANGUAGE C STRICT VOLATILE PARALLEL RESTRICTED;
+
+CREATE VIEW pg_stat_statements AS
+  SELECT * FROM pg_stat_statements(true);
+
+GRANT SELECT ON pg_stat_statements TO PUBLIC;
+
+/* Mark reset functions as PARALLEL RESTRICTED */
+ALTER FUNCTION pg_stat_statements_reset(Oid, Oid, bigint, boolean) PARALLEL RESTRICTED;
+
+/* Recreate pg_stat_statements_info with new columns */
+ALTER EXTENSION pg_stat_statements DROP VIEW pg_stat_statements_info;
+ALTER EXTENSION pg_stat_statements DROP FUNCTION pg_stat_statements_info();
+DROP VIEW pg_stat_statements_info;
+DROP FUNCTION pg_stat_statements_info();
+
+CREATE FUNCTION pg_stat_statements_info(
+    OUT dealloc bigint,
+    OUT stats_reset timestamp with time zone,
+    OUT skipped_entries bigint,
+    OUT query_text_size bigint,
+    OUT num_entries bigint
+)
+RETURNS record
+AS 'MODULE_PATHNAME'
+LANGUAGE C STRICT VOLATILE PARALLEL SAFE;
+
+CREATE VIEW pg_stat_statements_info AS
+  SELECT * FROM pg_stat_statements_info();
+
+GRANT SELECT ON pg_stat_statements_info TO PUBLIC;
diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 92315627916..b9140212501 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -5,34 +5,61 @@
  *		usage across a whole database cluster.
  *
  * Execution costs are totaled for each distinct source query, and kept in
- * a shared hashtable.  (We track only as many distinct queries as will fit
- * in the designated amount of shared memory.)
+ * shared memory as a custom pgstat kind (own_hash=true), giving this module
+ * its own dedicated dshash table.  Query text is stored in a separate DSA
+ * area (via DSM registry).
  *
- * Starting in Postgres 9.2, this module normalized query entries.  As of
- * Postgres 14, the normalization is done by the core if compute_query_id is
- * enabled, or optionally by third-party modules.
+ * Normalization of query constants is performed by the core query jumble
+ * machinery (compute_query_id).  This module stores a "representative"
+ * query string with constants replaced by parameter symbols ($n).
  *
- * To facilitate presenting entries to users, we create "representative" query
- * strings in which constants are replaced with parameter symbols ($n), to
- * make it clearer what a normalized entry can represent.  To save on shared
- * memory, and to avoid having to truncate oversized query strings, we store
- * these strings in a temporary external query-texts file.  Offsets into this
- * file are kept in shared memory.
+ * Entry metadata (key, query text pointer, usage counter, timestamps) and
+ * counters live together in the PgStatShared_Pgss body.  Backends accumulate
+ * stats locally via the pending/flush infrastructure, flushing to shared
+ * memory without contending on entry-level locks on the hot path.  All
+ * locking (per-entry LWLock, dshash partition locks) is provided by the
+ * core pgstat infrastructure.
  *
- * Note about locking issues: to create or delete an entry in the shared
- * hashtable, one must hold pgss->lock exclusively.  Modifying any field
- * in an entry except the counters requires the same.  To look up an entry,
- * one must hold the lock shared.  To read or update the counters within
- * an entry, one must hold the lock shared or exclusive (so the entry doesn't
- * disappear!) and also take the entry's mutex spinlock.
- * The shared state variable pgss->extent (the next free spot in the external
- * query-text file) should be accessed only while holding either the
- * pgss->mutex spinlock, or exclusive lock on pgss->lock.  We use the mutex to
- * allow reserving file space while holding only shared lock on pgss->lock.
- * Rewriting the entire external query-text file, eg for garbage collection,
- * requires holding pgss->lock exclusively; this allows individual entries
- * in the file to be read or written while holding only shared lock.
+ * Locking strategy for entry creation:
  *
+ * The hot path (existing entries) is lock-free: the backend holds a
+ * cached local reference to the entry (or acquires one via a dshash
+ * lookup on first access), then pending stats are accumulated in
+ * backend-local memory without any external lock.
+ *
+ * New entries require an exclusive LWLock (pgss_shared->lock) to serialize
+ * creation against concurrent eviction.  This lock is only taken when the
+ * entry does not already exist (cache miss), which is rare in steady state.
+ *
+ * Eviction:
+ *
+ * When the live entry count reaches pgss_max, eviction is triggered
+ * under the exclusive lock.  At most one eviction pass runs per
+ * PGSS_EVICT_INTERVAL_MS (globally across all backends) to prevent
+ * lock convoy effects under
+ * high-churn workloads.  Between passes, backends that would need to
+ * create a new entry simply skip recording.
+ *
+ * Each eviction pass scans all entries, sorts by last_access timestamp
+ * (LRU, least recently used first), and drops the bottom 1/N (where
+ * N = PGSS_EVICT_RATIO).  A grace period (PGSS_EVICT_GRACE_MS)
+ * protects entries accessed recently from eviction, even if they rank among
+ * the coldest.  This prevents a churn cycle where the same active
+ * entries are evicted and immediately re-created, consuming eviction
+ * capacity without admitting genuinely new queries.  Only entries that
+ * are truly stale (not accessed recently) are evicted, which means they
+ * are unlikely to be pinned by backends and can be freed immediately.
+ *
+ * Eviction decisions use a live entry count (incremented on creation,
+ * decremented on eviction) rather than the physical dshash size, which
+ * includes dropped-but-pinned entries awaiting GC.  This ensures
+ * headroom is available immediately after eviction without waiting for
+ * backends to release their refs.
+ *
+ * To avoid runaway growth of the dshash when long-running transactions
+ * hold refs and prevent GC from freeing evicted entries, creation is
+ * skipped unconditionally once the physical entry count reaches 2x
+ * pgss_max.
  *
  * Copyright (c) 2008-2026, PostgreSQL Global Development Group
  *
@@ -44,30 +71,30 @@
 #include "postgres.h"
 
 #include <math.h>
-#include <sys/stat.h>
-#include <unistd.h>
 
 #include "access/htup_details.h"
 #include "access/parallel.h"
 #include "catalog/pg_authid.h"
+#include "common/hashfn.h"
 #include "executor/instrument.h"
 #include "funcapi.h"
 #include "jit/jit.h"
+#include "lib/dshash.h"
 #include "mb/pg_wchar.h"
 #include "miscadmin.h"
+#include "pgstat.h"
 #include "nodes/queryjumble.h"
 #include "optimizer/planner.h"
 #include "parser/analyze.h"
-#include "pgstat.h"
-#include "storage/fd.h"
-#include "storage/ipc.h"
-#include "storage/lwlock.h"
-#include "storage/shmem.h"
-#include "storage/spin.h"
+#include "storage/dsm_registry.h"
 #include "tcop/utility.h"
+#include "access/xact.h"
 #include "utils/acl.h"
 #include "utils/builtins.h"
-#include "utils/memutils.h"
+#include "utils/dsa.h"
+#include "utils/guc.h"
+#include "utils/numeric.h"
+#include "utils/pgstat_internal.h"
 #include "utils/timestamp.h"
 #include "utils/tuplestore.h"
 
@@ -76,29 +103,26 @@ PG_MODULE_MAGIC_EXT(
 					.version = PG_VERSION
 );
 
-/* Location of permanent stats file (valid when database is shut down) */
-#define PGSS_DUMP_FILE	PGSTAT_STAT_PERMANENT_DIRECTORY "/pg_stat_statements.stat"
+/* Custom pgstat kind ID */
+#define PGSTAT_KIND_PGSS	25
+
+/* Fraction of pgss_max to evict per pass (1/N) */
+#define PGSS_EVICT_RATIO		10
 
 /*
- * Location of external query text file.
+ * Minimum interval (ms) between eviction passes.  Limits lock hold time
+ * under high-churn workloads to at most one scan+sort per this interval.
  */
-#define PGSS_TEXT_FILE	PG_STAT_TMP_DIR "/pgss_query_texts.stat"
-
-/* Magic number identifying the stats file format */
-static const uint32 PGSS_FILE_HEADER = 0x20250731;
+#define PGSS_EVICT_INTERVAL_MS	1000
 
-/* PostgreSQL major version number, changes in which invalidate all entries */
-static const uint32 PGSS_PG_MAJOR_VERSION = PG_VERSION_NUM / 100;
-
-/* XXX: Should USAGE_EXEC reflect execution time and/or buffer usage? */
-#define USAGE_EXEC(duration)	(1.0)
-#define USAGE_INIT				(1.0)	/* including initial planning */
-#define ASSUMED_MEDIAN_INIT		(10.0)	/* initial assumed median usage */
-#define ASSUMED_LENGTH_INIT		1024	/* initial assumed mean query length */
-#define USAGE_DECREASE_FACTOR	(0.99)	/* decreased every entry_dealloc */
-#define STICKY_DECREASE_FACTOR	(0.50)	/* factor for sticky entries */
-#define USAGE_DEALLOC_PERCENT	5	/* free this % of entries at once */
-#define IS_STICKY(c)	((c.calls[PGSS_PLAN] + c.calls[PGSS_EXEC]) == 0)
+/*
+ * Grace period (ms) protecting recently-accessed entries from eviction.
+ * Entries whose last_access is within this window are skipped even if they
+ * rank among the coldest.  Without this, entries that are still being
+ * executed get evicted and immediately re-created, wasting eviction
+ * capacity without making room for genuinely new queries.
+ */
+#define PGSS_EVICT_GRACE_MS		10000
 
 /*
  * Extension version number, for supporting older extension versions' objects
@@ -116,7 +140,6 @@ typedef enum pgssVersion
 	PGSS_V1_12,
 	PGSS_V1_13,
 } pgssVersion;
-
 typedef enum pgssStoreKind
 {
 	PGSS_INVALID = -1,
@@ -133,12 +156,9 @@ typedef enum pgssStoreKind
 #define PGSS_NUMKIND (PGSS_EXEC + 1)
 
 /*
- * Hashtable key that defines the identity of a hashtable entry.  We separate
- * queries by user and by database even if they are otherwise identical.
- *
- * If you add a new key to this struct, make sure to teach pgss_store() to
- * zero the padding bytes.  Otherwise, things will break, because pgss_hash is
- * created using HASH_BLOBS, and thus tag_hash is used to hash this.
+ * Hashtable key that defines the identity of a tracked statement.
+ * We separate queries by user and by database even if they are otherwise
+ * identical.
  */
 typedef struct pgssHashKey
 {
@@ -149,9 +169,9 @@ typedef struct pgssHashKey
 } pgssHashKey;
 
 /*
- * The actual stats counters kept within pgssEntry.
+ * The actual stats counters kept within the custom pgstat kind.
  */
-typedef struct Counters
+typedef struct pgssCounters
 {
 	int64		calls[PGSS_NUMKIND];	/* # of times planned/executed */
 	double		total_time[PGSS_NUMKIND];	/* total planning/execution time,
@@ -212,65 +232,71 @@ typedef struct Counters
 											 * launched */
 	int64		generic_plan_calls; /* number of calls using a generic plan */
 	int64		custom_plan_calls;	/* number of calls using a custom plan */
-} Counters;
-
-/*
- * Global statistics for pg_stat_statements
- */
-typedef struct pgssGlobalStats
-{
-	int64		dealloc;		/* # of times entries were deallocated */
-	TimestampTz stats_reset;	/* timestamp with all stats reset */
-} pgssGlobalStats;
+} pgssCounters;
 
 /*
- * Statistics per statement
- *
- * Note: in event of a failure in garbage collection of the query text file,
- * we reset query_offset to zero and query_len to -1.  This will be seen as
- * an invalid state by qtext_fetch().
+ * Shared pgstat entry  - stored in the per-kind dshash (own_hash).
+ * Contains both the stats counters and the entry metadata that was
+ * previously stored in a separate dshash registry.
  */
-typedef struct pgssEntry
+typedef struct PgStatShared_Pgss
 {
-	pgssHashKey key;			/* hash key of entry - MUST BE FIRST */
-	Counters	counters;		/* the statistics for this query */
-	Size		query_offset;	/* query text offset in external file */
+	PgStatShared_Common header;
+	pgssHashKey key;
+	dsa_pointer query_text;		/* DSA pointer to query text */
 	int			query_len;		/* # of valid bytes in query string, or -1 */
 	int			encoding;		/* query text encoding */
 	TimestampTz stats_since;	/* timestamp of entry allocation */
 	TimestampTz minmax_stats_since; /* timestamp of last min/max values reset */
-	slock_t		mutex;			/* protects the counters only */
-} pgssEntry;
+	pg_atomic_uint32 usage;		/* hotness: decremented by sweep, incremented
+								 * on access */
+	pg_atomic_uint64 last_access;	/* statement start timestamp of last
+									 * access, for LRU eviction */
+	pgssCounters counters;
+} PgStatShared_Pgss;
 
 /*
- * Global shared state
+ * Global shared state stored in DSM segment
  */
 typedef struct pgssSharedState
 {
-	LWLockPadded lock;			/* protects hashtable search/modification */
-	double		cur_median_usage;	/* current median usage in hashtable */
-	Size		mean_query_len; /* current mean entry text length */
-	slock_t		mutex;			/* protects following fields only: */
-	Size		extent;			/* current extent of query file */
-	int			n_writers;		/* number of active writers to query file */
-	int			gc_count;		/* query file garbage collection cycle count */
-	pgssGlobalStats stats;		/* global statistics for pgss */
-} pgssSharedState;
+	LWLock		lock;			/* protects entry creation and eviction */
+	pg_atomic_uint64 dealloc;	/* total # of entries evicted */
+	pg_atomic_uint64 skipped_entries;	/* # of entries skipped due to
+										 * throttle */
+	pg_atomic_uint64 stats_reset;	/* timestamp with all stats reset */
+
+	/*
+	 * Live entry count: tracks non-dropped entries.  We need this separate
+	 * from pgstat_get_entry_count() because the core counter includes
+	 * dropped-but-pinned entries still held by backend references.
+	 */
+	pg_atomic_uint64 live_entries;
 
-/* Links to shared memory state */
-static pgssSharedState *pgss;
-static HTAB *pgss_hash;
+	/* Timestamp of last eviction pass; limits to once per second globally */
+	pg_atomic_uint64 last_eviction;
+} pgssSharedState;
 
-static void pgss_shmem_request(void *arg);
-static void pgss_shmem_init(void *arg);
+/* Backend-local pending entry */
+typedef struct PgStat_PgssPending
+{
+	pgssHashKey key;
+	bool		last_access_updated;
+	pgssCounters counters;
+} PgStat_PgssPending;
 
-static const ShmemCallbacks pgss_shmem_callbacks = {
-	.request_fn = pgss_shmem_request,
-	.init_fn = pgss_shmem_init,
-};
 
 /*---- Local variables ----*/
 
+/* Global shared state */
+static pgssSharedState *pgss_shared = NULL;
+
+/* Query text dsa area */
+static dsa_area *pgss_qtext_dsa = NULL;
+
+/* Per-kind pgstat dshash for this kind */
+static dshash_table *pgss_hash = NULL;
+
 /* Current nesting depth of planner/ExecutorRun/ProcessUtility calls */
 static int	nesting_level = 0;
 
@@ -305,20 +331,17 @@ static int	pgss_track = PGSS_TRACK_TOP;	/* tracking level */
 static bool pgss_track_utility = true;	/* whether to track utility commands */
 static bool pgss_track_planning = false;	/* whether to track planning
 											 * duration */
-static bool pgss_save = true;	/* whether to save stats across shutdown */
+static bool pgss_save = true;	/* whether to save stats across shutdown XXX:
+								 * this does not prevent stats being saved to
+								 * the core stats file, should it? */
+static int	pgss_query_text_memory = 4096;	/* in KB XXX: Should default be
+											 * lower? */
 
 #define pgss_enabled(level) \
 	(!IsParallelWorker() && \
 	(pgss_track == PGSS_TRACK_ALL || \
 	(pgss_track == PGSS_TRACK_TOP && (level) == 0)))
 
-#define record_gc_qtexts() \
-	do { \
-		SpinLockAcquire(&pgss->mutex); \
-		pgss->gc_count++; \
-		SpinLockRelease(&pgss->mutex); \
-	} while(0)
-
 /*---- Function declarations ----*/
 
 PG_FUNCTION_INFO_V1(pg_stat_statements_reset);
@@ -335,7 +358,6 @@ PG_FUNCTION_INFO_V1(pg_stat_statements_1_13);
 PG_FUNCTION_INFO_V1(pg_stat_statements);
 PG_FUNCTION_INFO_V1(pg_stat_statements_info);
 
-static void pgss_shmem_shutdown(int code, Datum arg);
 static void pgss_post_parse_analyze(ParseState *pstate, Query *query,
 									const JumbleState *jstate);
 static PlannedStmt *pgss_planner(Query *parse,
@@ -365,24 +387,102 @@ static void pgss_store(const char *query, int64 queryId,
 					   int parallel_workers_to_launch,
 					   int parallel_workers_launched,
 					   PlannedStmtOrigin planOrigin);
-static void pg_stat_statements_internal(FunctionCallInfo fcinfo,
-										pgssVersion api_version,
-										bool showtext);
-static pgssEntry *entry_alloc(pgssHashKey *key, Size query_offset, int query_len,
-							  int encoding, bool sticky);
-static void entry_dealloc(void);
-static bool qtext_store(const char *query, int query_len,
-						Size *query_offset, int *gc_count);
-static char *qtext_load_file(Size *buffer_size);
-static char *qtext_fetch(Size query_offset, int query_len,
-						 char *buffer, Size buffer_size);
-static bool need_gc_qtexts(void);
-static void gc_qtexts(void);
+static void pgss_assign_query_text_memory(int newval, void *extra);
+static void pgss_attach_shmem(void);
 static TimestampTz entry_reset(Oid userid, Oid dbid, int64 queryid, bool minmax_only);
+static inline uint64 pgss_hash_key(pgssHashKey *key);
 static char *generate_normalized_query(const JumbleState *jstate,
 									   const char *query,
 									   int query_loc, int *query_len_p);
 
+static void pg_stat_statements_internal(FunctionCallInfo fcinfo,
+										pgssVersion api_version,
+										bool showtext);
+
+static bool pgss_flush_pending_cb(PgStat_EntryRef *entry_ref, bool nowait);
+static void pgss_to_serialized_data(const PgStat_HashKey *key,
+									const PgStatShared_Common *header,
+									FILE *statfile);
+static bool pgss_from_serialized_data(const PgStat_HashKey *key,
+									  PgStatShared_Common *header,
+									  FILE *statfile);
+
+/*--------------------------------------------------------------------------
+ * Custom pgstat kind definition
+ *--------------------------------------------------------------------------
+ */
+
+static const PgStat_KindInfo pgss_kind_info = {
+	.name = "pg_stat_statements",
+	.fixed_amount = false,
+	.write_to_file = true,
+	.track_entry_count = true,
+	.accessed_across_databases = true,
+	.own_hash = true,
+	.shared_size = sizeof(PgStatShared_Pgss),
+	.shared_data_off = offsetof(PgStatShared_Pgss, counters),
+	.shared_data_len = sizeof(pgssCounters),
+	.pending_size = sizeof(PgStat_PgssPending),
+	.init_backend_cb = pgss_attach_shmem,
+	.flush_pending_cb = pgss_flush_pending_cb,
+	.to_serialized_data = pgss_to_serialized_data,
+	.from_serialized_data = pgss_from_serialized_data,
+};
+
+static inline uint64
+pgss_hash_key(pgssHashKey *key)
+{
+	return hash_bytes_extended((const unsigned char *) key,
+							   sizeof(pgssHashKey), 0);
+}
+
+static void
+pgss_init_shmem(void *ptr, void *arg)
+{
+	pgssSharedState *state = (pgssSharedState *) ptr;
+
+	LWLockInitialize(&state->lock, LWLockNewTrancheId("pg_stat_statements"));
+	pg_atomic_init_u64(&state->dealloc, 0);
+	pg_atomic_init_u64(&state->skipped_entries, 0);
+	pg_atomic_init_u64(&state->stats_reset, (uint64) GetCurrentTimestamp());
+	pg_atomic_init_u64(&state->live_entries, 0);
+	pg_atomic_init_u64(&state->last_eviction, 0);
+}
+
+static void
+pgss_assign_query_text_memory(int newval, void *extra)
+{
+	if (pgss_qtext_dsa)
+		dsa_set_size_limit(pgss_qtext_dsa, (size_t) newval * 1024);
+}
+
+static void
+pgss_attach_shmem(void)
+{
+	bool		found;
+
+	if (pgss_shared != NULL)
+		return;
+	if (!pgstat_get_kind_info(PGSTAT_KIND_PGSS))
+		ereport(ERROR,
+				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				 errmsg("pg_stat_statements must be loaded via shared_preload_libraries")));
+
+	pgss_shared = GetNamedDSMSegment("pg_stat_statements_state",
+									 sizeof(pgssSharedState),
+									 pgss_init_shmem,
+									 &found, NULL);
+
+	if (pgss_qtext_dsa == NULL)
+	{
+		pgss_qtext_dsa = GetNamedDSA("pg_stat_statements_qtext", &found);
+		dsa_set_size_limit(pgss_qtext_dsa, (size_t) pgss_query_text_memory * 1024);
+	}
+
+	if (pgss_hash == NULL)
+		pgss_hash = pgstat_get_hash_for_kind(PGSTAT_KIND_PGSS);
+}
+
 /*
  * Module load callback
  */
@@ -390,7 +490,7 @@ void
 _PG_init(void)
 {
 	/*
-	 * In order to create our shared memory area, we have to be loaded via
+	 * In order to register our custom pgstat kind, we have to be loaded via
 	 * shared_preload_libraries.  If not, fall out without hooking into any of
 	 * the main system.  (We don't throw error here because it seems useful to
 	 * allow the pg_stat_statements functions to be created even when the
@@ -406,9 +506,10 @@ _PG_init(void)
 	 */
 	EnableQueryId();
 
-	/*
-	 * Define (or redefine) custom GUC variables.
-	 */
+	/* Register custom pgstat kind */
+	pgstat_register_kind(PGSTAT_KIND_PGSS, &pgss_kind_info);
+
+	/* Define GUCs */
 	DefineCustomIntVariable("pg_stat_statements.max",
 							"Sets the maximum number of statements tracked by pg_stat_statements.",
 							NULL,
@@ -416,7 +517,7 @@ _PG_init(void)
 							5000,
 							100,
 							INT_MAX / 2,
-							PGC_POSTMASTER,
+							PGC_SIGHUP,
 							0,
 							NULL,
 							NULL,
@@ -467,12 +568,20 @@ _PG_init(void)
 							 NULL,
 							 NULL);
 
-	MarkGUCPrefixReserved("pg_stat_statements");
+	DefineCustomIntVariable("pg_stat_statements.query_text_memory",
+							"Sets the memory limit for query text storage.",
+							NULL,
+							&pgss_query_text_memory,
+							4096,
+							256,
+							MAX_KILOBYTES,
+							PGC_SIGHUP,
+							GUC_UNIT_KB,
+							NULL,
+							pgss_assign_query_text_memory,
+							NULL);
 
-	/*
-	 * Register our shared memory needs.
-	 */
-	RegisterShmemCallbacks(&pgss_shmem_callbacks);
+	MarkGUCPrefixReserved("pg_stat_statements");
 
 	/*
 	 * Install hooks.
